<?php
namespace Claromentis\Setup\Task;

$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] ?: array()) + array("_9342063570b40df20752043" . "94b59df59" => base64_decode("Z2V0Y3" . "dk"), "_dcf86ccc3" . "1af7f63af3" . "6115aa12b1" . "ee7" => base64_decode("Y2" . "hk" . "aX" . "I="), "_d706c160e45bf7434fff82a5976f0e1" . "9" => base64_decode("YXJyYXlfa" . "2V5cw=="), "_a8f3e68b7b1" . "cd9e541fbc83" . "ec833aa91" => base64_decode("RHJvcHBpb" . "mcgc2NoZW" . "1h"), "_2d2a59c35e2175c18930e33b8d5547" . "71" => base64_decode("RHJvcHBpbmcgdGFibGUgJw=" . "="), "_e608e5b5c4c34" . "a67ba97ef84c1e" . "16199" => base64_decode("Jw=" . "="), "_762073860483e6c69" . "34f5698dfd40f63" => base64_decode("UnVubmluZyB1bmlu" . "c3RhbGwgc2NyaXB0"), "_8ee8ae7dae" . "ff23521c786" . "b245baf11d6" => base64_decode("Tm8gdW5pbnN0YWxsIHNjcmlwdCwg" . "Y2FsbGluZyBpbnN0YWxsZXIgd2l0" . "aCBzcGVjaWFsIGRhdGFiYXNlIGxh" . "eWVy"));
use Claromentis\Core\DAL\Db;
use Claromentis\Core\DAL\Schema\SchemaDb;
use Claromentis\Setup\Db\SchemaFacade;
use Claromentis\Setup\Logger;
use Psr\Log\LoggerAwareTrait;




class Uninstall
{
    use LoggerAwareTrait;
    
    
    
    
    protected $db;
    
    
    
    
    
    
    protected $application_path;
    
    
    
    
    
    
    
    public function __construct($db, $_4825e032d19ebe3edee32a6a54c7afd2)
    {
        $this->db = $db;
        $this->application_path = $_4825e032d19ebe3edee32a6a54c7afd2;
        $this->setLogger(new Logger());
    }
    
    
    
    
    
    
    
    public function Run($app_code)
    {
        $_3e91a953f0ae44bc853e303c034f9d93 = $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_9342063570b" . "40df20752043" . "94b59df59"]();
        $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_dcf86ccc31a" . "f7f63af36115" . "aa12b1ee7"]($this->application_path);
        $this->RunUninstallScript($app_code, $this->db);
        $this->DropSchema($app_code, $this->db);
        $_d3a4df576cec8d467e29e06a95ac4009 = new \Claromentis\Setup\Db\Migrations\PersistenceDatabase($app_code, $this->db, $this->logger);
        $_d3a4df576cec8d467e29e06a95ac4009->Delete();
        $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_dcf86ccc31af7f63af36" . "115aa12b1ee7"]($_3e91a953f0ae44bc853e303c034f9d93);
    }
    
    
    
    
    
    
    
    
    protected function RunUninstallScript($app_code, $_8bf9813aed9bb9b6d29793f34cc5e497)
    {
        $this->logger->info($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_762073860483e6c6934f5698d" . "fd40f63"]);
        $_d983f9f1dd6ce3533fdb230ac31d42d2 = new \Claromentis\Setup\Script\Uninstall($this->application_path);
        $_0ab271f12643b1e576aa1bc6db54cb4e = new \Claromentis\Setup\Script\Init($this->application_path);
        if ($_d983f9f1dd6ce3533fdb230ac31d42d2->Exists()) {
            try {
                $_876ca2097b275e704d71e00d36b3e7c5 = new \Claromentis\Setup\SetupFacade($_8bf9813aed9bb9b6d29793f34cc5e497);
                $_876ca2097b275e704d71e00d36b3e7c5->setLogger($this->logger);
                $_d983f9f1dd6ce3533fdb230ac31d42d2->Run($_876ca2097b275e704d71e00d36b3e7c5);
            } catch (\Exception $e) {
                
                
                $this->logger->error($e->getMessage());
            }
        } elseif ($_0ab271f12643b1e576aa1bc6db54cb4e->Exists()) {
            
            
            $this->logger->warning($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_8ee8ae7daeff23521c786b2" . "45baf11d6"]);
            $_323d081d228922f95bfd6f3ca2f078ed = new \Claromentis\Core\DAL\Uninstall\UninstallDb($_8bf9813aed9bb9b6d29793f34cc5e497);
            try {
                $_876ca2097b275e704d71e00d36b3e7c5 = new \Claromentis\Setup\SetupFacade($_323d081d228922f95bfd6f3ca2f078ed);
                $_876ca2097b275e704d71e00d36b3e7c5->SetProperties(array());
                $_0ab271f12643b1e576aa1bc6db54cb4e->Run($_876ca2097b275e704d71e00d36b3e7c5);
            } catch (\Exception $e) {
                
                
                $this->logger->error($e->getMessage());
            }
        }
    }
    
    
    
    
    
    
    
    protected function DropSchema($app_code, $_8bf9813aed9bb9b6d29793f34cc5e497)
    {
        $this->logger->info($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_a8f3e68b7b1cd9e541f" . "bc83ec833aa91"]);
        $_58445071c7cb1e19afa575bbe9f7b6db = new SchemaDb();
        try {
            
            
            $_5fc096a041b2b6628d96b426cebad88d = new \Claromentis\Setup\Db\Migrations\PersistenceTransient($app_code, $this->logger);
            $_c4a29a8f844bd63614b8f4a72c3a10fd = new SchemaFacade($_58445071c7cb1e19afa575bbe9f7b6db, $app_code, $this->application_path, $_5fc096a041b2b6628d96b426cebad88d);
            $_c4a29a8f844bd63614b8f4a72c3a10fd->Install();
        } catch (\Exception $e) {
            $this->logger->error($e->getMessage());
        }
        
        
        $_ba4b312a27a90d0b0e30368938d4213b = $_58445071c7cb1e19afa575bbe9f7b6db->GetTables();
        
        
        foreach ($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_d706c160e45bf7434fff82a" . "5976f0e19"]($_ba4b312a27a90d0b0e30368938d4213b) as $_c81a475ecdc9121925813756400e25f9) {
            $this->logger->info($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_2d2a59c35e2175c189" . "30e33b8d554771"] . $_c81a475ecdc9121925813756400e25f9 . $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_e608e5b5c4c34a67ba97e" . "f84c1e16199"]);
            $_8bf9813aed9bb9b6d29793f34cc5e497->DropTable($_c81a475ecdc9121925813756400e25f9);
        }
    }
}